<template lang="pug">
  div.lc-livestream
    div.ui.stackable.container
      h1.centered {{ name | upper }}'s Livestream
      p.subtitle.centered Livestream description functionality soon™
      div.ui.segment.inverted.centered
        div.lc-live-loading(v-if="loading")
          p.ui.row
            i.sync.icon
            | Please wait while we fetch the stream information...
          div.ui.placeholder.inverted
            div.rectangular.image
        div.lc-live-unsupported(v-else-if="!supported")
          p.ui.row
            i.exclamation.icon
            | We have detected that your browser doesn't support HLS playback.
        div.lc-live-offline(v-else-if="offline")
          p.ui.row
            i.power.switch.icon
            | It seems that this livestream is offline.
        div.lc.live.stream.warning(v-show="!loading && supported && !offline && !accepted")
          div.ui.segment.inverted
            div.lc.live.title
              i.eye.slash.outline.icon
              | Warning
            p
              | Streams might contain content not suitable for children or persons under the age of 18.
            div.ui.button.inverted(v-on:click="accept()") Understood
        div.lc-live-stream(v-show="!loading && supported && !offline && accepted")
          video(:poster="imgs.core.lcPoster" preload="none" id="stream" ref="stream" autoplay controls crossorigin)
            source(:src="source")
          span.ui.button.black.spaced(v-on:click="autoCatchUp = !autoCatchUp")
            | #[i(:class="(autoCatchUp ? 'check ' : '') + 'circle outline icon'")] Catch-Up
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'

import 'semantic-ui-css/components/container.min.css'
import 'semantic-ui-css/components/segment.min.css'
import 'semantic-ui-css/components/placeholder.min.css'
import 'semantic-ui-css/components/grid.min.css'

import Hls from 'hls.js'
import Plyr from 'plyr'
import 'plyr/dist/plyr.css'
import Api from '@/data/api'
import Images from '@/data/images'

const api = new Api()

function contains (where: string[], what: string): boolean {
  let contains = false
  where.forEach(itm => {
    if (itm === what) {
      contains = true
    }
  })
  return contains
}

@Component
export default class LCLivestream extends Vue {
  imgs = Images
  loading = true
  supported = true
  offline = false
  autoCatchUp = false
  accepted = window.localStorage.getItem('over_18') === 'yes'

  get name () {
    return this.$route.params[1]
  }

  get source () {
    return `${process.env.VUE_APP_STREAM_API_URL}/${this.name}/playlist.m3u8`
  }

  accept () {
    window.localStorage.setItem('over_18', 'yes')
    this.accepted = true
  }

  catchUp (plr: any) {
    if (plr.duration - plr.currentTime > 5 && plr.playing && this.autoCatchUp) {
      plr.forward((plr.duration - plr.currentTime) - 3)
    }
  }

  mounted () {
    const ctx = this
    api.getActiveStreams()
      .then(function (data) {
        if (!contains(data.streams, ctx.name)) {
          ctx.loading = false
          ctx.offline = true
        } else {
          if (!Hls.isSupported()) ctx.supported = false
          else {
            document.title = 'Lucia\'s Cipher - ' + ctx.name.toUpperCase() + '\'s Livestream'
            const video = ctx.$refs.stream as HTMLVideoElement
            const hls = new Hls()
            hls.loadSource(ctx.source)
            hls.attachMedia(video)
            const player = new Plyr('#' + video.id, {}) as any
            setInterval(() => {
              ctx.catchUp(player)
            }, 1000)
            ctx.loading = false
          }
        }
      })
  }
}
</script>

<style lang="stylus" scoped>
#stream
  width: 100%

.ui.placeholder.inverted
  max-width: unset
  & .rectangular.image:not(.header)
    padding-top: 56.25%

.lc-livestream::v-deep
  .plyr__time::before
    content: "Delay: "
  .plyr__volume input[type="range"]
    color: #95375b
  .plyr--video .plyr__control.plyr__tab-focus,
  .plyr--video .plyr__control:hover,
  .plyr--video .plyr__control[aria-expanded="true"],
  .plyr__control--overlaid
    background: #552a52
    &:active
      box-shadow: 0 0 0 5px #231a33
  .plyr__progress
    visibility: hidden

.lc.live.title
  font-size: 2rem

.ui.button.black.spaced
  margin-top: 1rem
</style>
